## python3.10 3.10.12

=== Doc/requirements.txt ===
# Requirements to build the Python documentation

# Sphinx version is pinned so that new versions that introduce new warnings
# won't suddenly cause build failures. Updating the version is fine as long
# as no warnings are raised by doing so.
sphinx==3.4.3
# Docutils version is pinned to a version compatible with Sphinx
# version <3.5.4. It can be removed after bumping Sphinx version to at
# least 3.5.4.
docutils==0.17.1
# Jinja version is pinned to a version compatible with Sphinx version <4.5.
jinja2==3.0.3

blurb

# The theme used by the documentation is stored separately, so we need
# to install that as well.
python-docs-theme>=2022.1

=== Tools/peg_generator/Makefile ===
UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S),Linux)
	PYTHON ?= ../../python
endif
ifeq ($(UNAME_S),Darwin)
	PYTHON ?= ../../python.exe
endif
VENVDIR ?= ./venv
VENVPYTHON ?= $(VENVDIR)/bin/python
CPYTHON ?= ../../Lib
MYPY ?= mypy

GRAMMAR = ../../Grammar/python.gram
TOKENS = ../../Grammar/Tokens
TESTFILE = data/cprog.py
TIMEFILE = data/xxl.py
TESTDIR = .
TESTFLAGS = --short

data/xxl.py:
	$(PYTHON) -m zipfile -e data/xxl.zip data

build: peg_extension/parse.c

peg_extension/parse.c: $(GRAMMAR) $(TOKENS) pegen/*.py peg_extension/peg_extension.c ../../Parser/pegen.c ../../Parser/string_parser.c ../../Parser/*.h pegen/grammar_parser.py
	$(PYTHON) -m pegen -q c $(GRAMMAR) $(TOKENS) -o peg_extension/parse.c --compile-extension

clean:
	-rm -f peg_extension/*.o peg_extension/*.so peg_extension/parse.c
	-rm -f data/xxl.py
	-rm -rf $(VENVDIR)

dump: peg_extension/parse.c
	cat -n $(TESTFILE)
	$(PYTHON) -c "from peg_extension import parse; import ast; t = parse.parse_file('$(TESTFILE)', mode=1); print(ast.dump(t))"

regen-metaparser: pegen/metagrammar.gram pegen/*.py
	$(PYTHON) -m pegen -q python pegen/metagrammar.gram -o pegen/grammar_parser.py

# Note: These targets really depend on the generated shared object in peg_extension/parse.*.so but
# this has different names in different systems so we are abusing the implicit dependency on
# parse.c by the use of --compile-extension.

.PHONY: test

venv:
	$(PYTHON) -m venv $(VENVDIR)
	$(VENVPYTHON) -m pip install -U pip setuptools
	$(VENVPYTHON) -m pip install -r requirements.pip
	@echo "The venv has been created in the $(VENVDIR) directory"

test: run

run: peg_extension/parse.c
	$(PYTHON) -c "from peg_extension import parse; t = parse.parse_file('$(TESTFILE)'); exec(t)"

compile: peg_extension/parse.c
	$(PYTHON) -c "from peg_extension import parse; t = parse.parse_file('$(TESTFILE)', mode=2)"

parse: peg_extension/parse.c
	$(PYTHON) -c "from peg_extension import parse; t = parse.parse_file('$(TESTFILE)', mode=1)"

check: peg_extension/parse.c
	$(PYTHON) -c "from peg_extension import parse; t = parse.parse_file('$(TESTFILE)', mode=0)"

stats: peg_extension/parse.c data/xxl.py
	$(PYTHON) -c "from peg_extension import parse; t = parse.parse_file('$(TIMEFILE)', mode=0); parse.dump_memo_stats()" >@data
	$(PYTHON) scripts/joinstats.py @data

time: time_compile

time_compile: venv data/xxl.py
	$(VENVPYTHON) scripts/benchmark.py --target=xxl compile

time_parse: venv data/xxl.py
	$(VENVPYTHON) scripts/benchmark.py --target=xxl parse

time_peg_dir: venv
	$(VENVPYTHON) scripts/test_parse_directory.py \
		-d $(TESTDIR) \
		$(TESTFLAGS) \
		--exclude "*/failset/*" \
		--exclude "*/failset/**" \
		--exclude "*/failset/**/*"

time_stdlib: $(CPYTHON) venv
	$(VENVPYTHON) scripts/test_parse_directory.py \
		-d $(CPYTHON) \
		$(TESTFLAGS) \
		--exclude "*/bad*" \
		--exclude "*/lib2to3/tests/data/*"

mypy: regen-metaparser
	$(MYPY)  # For list of files, see mypy.ini

format-python:
	black pegen scripts

format: format-python

find_max_nesting:
	$(PYTHON) scripts/find_max_nesting.py

tags: TAGS

TAGS: pegen/*.py test/test_pegen.py
	etags pegen/*.py test/test_pegen.py

=== debian/changelog ===
python3.10 (3.10.12-1~22.04.11) jammy-security; urgency=medium

  * SECURITY UPDATE: Regular expression denial of service.
    - debian/patches/CVE-2025-6069.patch: Improve regex parsing in
      Lib/html/parser.py.
    - CVE-2025-6069
  * SECURITY UPDATE: Infinite loop when parsing tar archives.
    - debian/patches/CVE-2025-8194.patch: Raise exception when count < 0 in
      Lib/tarfile.py.
    - CVE-2025-8194

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Fri, 15 Aug 2025 12:02:43 -0230

python3.10 (3.10.12-1~22.04.10) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect address list folding
    - debian/patches/CVE-2025-1795-1.patch: don't encode list separators in
      Lib/email/_header_value_parser.py,
      Lib/test/test_email/test__header_value_parser.py.
    - debian/patches/CVE-2025-1795-2.patch: fix AttributeError in the email
      module in Lib/email/_header_value_parser.py,
      Lib/test/test_email/test__header_value_parser.py.
    - CVE-2025-1795
  * SECURITY UPDATE: DoS via bytes.decode with unicode_escape
    - debian/patches/CVE-2025-4516.patch: fix use-after-free in the
      unicode-escape decoder with an error handler in
      Include/cpython/bytesobject.h, Include/cpython/unicodeobject.h,
      Lib/test/test_codeccallbacks.py, Lib/test/test_codecs.py,
      Objects/bytesobject.c, Objects/unicodeobject.c,
      Parser/string_parser.c.
    - CVE-2025-4516

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 27 May 2025 13:12:29 -0400

python3.10 (3.10.12-1~22.04.9) jammy-security; urgency=medium

  * SECURITY UPDATE: urlparse does not flag hostname with square brackets
    as incorrect
    - debian/patches/CVE-2025-0938.patch: disallow square brackets in
      domain names for parsed URLs in Lib/test/test_urlparse.py,
      Lib/urllib/parse.py.
    - CVE-2025-0938

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 04 Feb 2025 09:57:36 -0500

python3.10 (3.10.12-1~22.04.8) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect validation of bracketed hosts
    - debian/patches/CVE-2024-11168.patch: add checks to ensure that
      bracketed hosts found by urlsplit are of IPv6 or IPvFuture format in
      Lib/urllib/parse.py, Lib/test/test_urlparse.py.
    - CVE-2024-11168

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 17 Jan 2025 09:35:34 -0500

python3.10 (3.10.12-1~22.04.7) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect quoting in venv module
    - debian/patches/CVE-2024-9287.patch: quote template strings in venv
      activation scripts in Lib/test/test_venv.py, Lib/venv/__init__.py,
      Lib/venv/scripts/common/activate, Lib/venv/scripts/nt/activate.bat,
      Lib/venv/scripts/posix/activate.csh,
      Lib/venv/scripts/posix/activate.fish.
    - CVE-2024-9287

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 06 Nov 2024 15:22:13 -0500

python3.10 (3.10.12-1~22.04.6) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect special character parsing in email module
    - debian/patches/CVE-2023-27043.patch: reject malformed addresses in
      Doc/library/email.utils.rst, Lib/email/utils.py,
      Lib/test/test_email/test_email.py.
    - CVE-2023-27043
  * SECURITY UPDATE: ReDoS via specifically-crafted tar archives
    - debian/patches/CVE-2024-6232.patch: remove backtracking when parsing
      tarfile headers in Lib/tarfile.py, Lib/test/test_tarfile.py.
    - CVE-2024-6232
  * SECURITY UPDATE: header injection via newlines in email module
    - debian/patches/CVE-2024-6923.patch: encode newlines in headers, and
      verify headers are sound in Doc/library/email.errors.rst,
      Doc/library/email.policy.rst, Lib/email/_header_value_parser.py,
      Lib/email/_policybase.py, Lib/email/errors.py,
      Lib/email/generator.py, Lib/test/test_email/test_generator.py,
      Lib/test/test_email/test_policy.py.
    - CVE-2024-6923
  * SECURITY UPDATE: resource consumption via cookie parsing
    - debian/patches/CVE-2024-7592.patch: fix quadratic complexity in
      parsing quoted cookie values with backslashes in Lib/http/cookies.py,
      Lib/test/test_http_cookies.py.
    - CVE-2024-7592
  * SECURITY UPDATE: infinite loop via crafted zip archive
    - debian/patches/CVE-2024-8088-1.patch: sanitize names in zipfile.Path
      in Lib/test/test_zipfile/_path/test_path.py,
      Lib/zipfile/_path/__init__.py.
    - debian/patches/CVE-2024-8088-2.patch: replaced SanitizedNames with a
      more surgical fix in Lib/test/test_zipfile/_path/test_path.py,
      Lib/zipfile/_path/__init__.py.
    - CVE-2024-8088

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 11 Sep 2024 11:47:36 -0400

python3.10 (3.10.12-1~22.04.5) jammy-security; urgency=medium

  * SECURITY UPDATE: race condition in ssl.SSLContext methods
    - debian/patches/CVE-2024-0397.patch: fix locking in cert_store_stats
      and get_ca_certs in Modules/_ssl.c.
    - CVE-2024-0397
  * SECURITY UPDATE: is_private and is_global mismatch
    - debian/patches/CVE-2024-4032.patch: fix "private" (non-global) IP
      address ranges in Doc/library/ipaddress.rst, Lib/ipaddress.py,
      Lib/test/test_ipaddress.py.
    - CVE-2024-4032

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 29 Jul 2024 12:56:48 -0400

python3.10 (3.10.12-1~22.04.4) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect permission assignment
    - debian/patches/CVE-2023-6597.patch: fix symlink bug in cleanup.
    - CVE-2023-6597
  * SECURITY UPDATE: zipbomb DoS attack
    - debian/patches/CVE-2024-0450.patch: raise BadZipFile when trying
      to read an entry that overlaps with other entry or central
      directory.
    - CVE-2024-0450

 -- Allen Huang <allen.huang@canonical.com>  Fri, 22 Mar 2024 16:50:05 +0000

python3.10 (3.10.12-1~22.04.3) jammy-security; urgency=medium

  * SECURITY UPDATE: TLS handshake bypass
    - debian/patches/CVE-2023-40217.patch: avoid ssl pre-close flaw in ssl.py.
    - CVE-2023-40217



=== debian/control ===
Source: python3.10
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev | libeditreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.5.1~),
  libbluetooth-dev [linux-any] <!pkg.python3.10.nobluetooth>,
  locales-all,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [linux-any],
  media-types | mime-support, netbase, bzip2, time, python3:any, python3.10:any <cross>,
  net-tools, xvfb <!nocheck>, xauth <!nocheck>,
  systemtap-sdt-dev,
  valgrind [!riscv64],
Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/cpython-team/python3/tree/python3.10
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git -b python3.10
XS-Testsuite: autopkgtest

Package: python3.10
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.10-minimal (= ${binary:Version}),
 libpython3.10-stdlib (= ${binary:Version}),
 media-types | mime-support,
 ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.10-venv, python3.10-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2)
Description: Interactive high-level object-oriented language (version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.10-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.10 (= ${binary:Version}),
 python3-pip-whl,
 python3-setuptools-whl,
 python3.10-distutils,
 ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.10 binary.

Package: libpython3.10-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-minimal (= ${binary:Version}),
  media-types | mime-support,
  ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-gdbm (<< 3.9.9-1~)
Replaces: python3-gdbm (<< 3.9.9-1~)
Description: Interactive high-level object-oriented language (standard library, version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.10's standard library. It is normally not
 used on its own, but as a dependency of python3.10.

Package: python3.10-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.10-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.10
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.10)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.10-minimal/README.Debian for a list of the modules
 contained in this package.
XB-Cnf-Visible-Pkgname: python3.10

Package: python3.10-nopie
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.10-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Python interpreter linked without PIE (version 3.10)
 This package contains the interpreter not built as position independent
 executable. This interpreter is diverting the python3.10 executable, and making
 the interpreter built with PIE available as python3.10-pie.
XB-Cnf-Visible-Pkgname: python3.10

Package: libpython3.10-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.10-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.10)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.10-minimal.

Package: libpython3.10
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.10-examples
Architecture: all
Depends: python3.10:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.10)
 Examples, Demos and Tools for Python (v3.10). These are files included in
 the upstream Python distribution (v3.10).

Package: python3.10-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.10 (= ${binary:Version}),
  libpython3.10-dev (= ${binary:Version}),
  libpython3.10 (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.10)
 Header files, a static library and development tools for building
 Python (v3.10) modules, extending the Python interpreter or embedding
 Python (v3.10) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.10-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-stdlib (= ${binary:Version}),
  libpython3.10 (= ${binary:Version}),
  libexpat1-dev, zlib1g-dev,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.10)
 Header files, a static library and development tools for building
 Python (v3.10) modules, extending the Python interpreter or embedding
 Python (v3.10) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.10-dev.

Package: libpython3.10-testsuite
Section: libdevel
Architecture: all
Depends: python3.10 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.10)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.10-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.10-stdlib package).

Package: idle-python3.10
Architecture: all
Depends: python3.10, python3-tk, python3.10-tk,
  ${misc:Depends},
  libjs-mathjax,
Enhances: python3.10
Description: IDE for Python (v3.10) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.10).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.10-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.10
Description: Documentation for the high-level object-oriented language Python (v3.10)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.10). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.10
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.10-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.10 (= ${binary:Version}), libpython3.10-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.10)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.10-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-gdbm-dbg (<< 3.9.9-1~)
Replaces: python3-gdbm-dbg (<< 3.9.9-1~)
Description: Debug Build of the Python Interpreter (version 3.10)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

Package: python3.10-full
Architecture: any
Multi-Arch: allowed
Depends: python3.10 (= ${binary:Version}),
  libpython3.10-testsuite,
  python3.10-venv (= ${binary:Version}),
  idle-python3.10,
  python3.10-distutils,
  python3.10-gdbm,
  python3.10-lib2to3,
  python3.10-tk,
  ca-certificates,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.10-doc, python3.10-examples,
Suggests: python3.10-dev
Description: Python Interpreter with complete class library (version 3.10)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on the full
 standard library of Python for Python developers. Including modules
 used only at build-time, such as venv and distutils, and modules with
 complex dependencies, such as tk and IDLE. All batteries included.
 .
 According to the Debian Python policy, this package must not be used in
 build dependencies, dependencies and recommendations.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS=hardening=-pie dpkg-buildflags
dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS=hardening=-pie dpkg-buildflags
ifeq (,$(filter $(distrelease),stretch buster bullseye trusty xenial bionic focal impish))
  with_nopie := yes
  dpkg_pieflags = dpkg-buildflags
endif

# FIXME: remove sid when uploading to unstable, after bookworm is released
#ifneq (,$(filter $(distrelase), jessie stretch buster bullseye bookworm sid precise trusty xenial bionic focal groovy hirsute))
  with_dbmmodule = yes
  bd_dbm = libdb-dev
  dbmliborder = bdb:gdbm
#else
#  bd_dbm = libgdbm-compat-dev
#  dbmliborder = gdbm:bdb
#endif

ifneq (,$(filter valgrind, $(shell dpkg-query --show -f '$${Depends}\n' valgrind-if-available)))
  valgrind_configure_args = --with-valgrind
endif

VER=3.10
SVER=3.10.0
NVER=3.11
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
  # test_ssl assumes that openssl is compiled with security level set to 1
  # make it so, during the build
  export OPENSSL_CONF = $(CURDIR)/debian/openssl.cnf
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

# configure and dtrace consume these
export CC CXX

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

DPKG_PIE_CPPFLAGS= $(shell $(dpkg_pieflags) --get CPPFLAGS)
DPKG_PIE_CFLAGS  := $(shell $(dpkg_pieflags) --get CFLAGS)
DPKG_PIE_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_PIE_CFLAGS))
DPKG_PIE_LDFLAGS = $(shell $(dpkg_pieflags) --get LDFLAGS)
OPT_PIE_CFLAGS   := $(filter-out -O%,$(DPKG_PIE_CFLAGS)) # default is -O3

ifeq ($(DEB_HOST_ARCH),ia64)
    DPKG_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
endif
# see #972202, and https://gcc.gnu.org/PR97431
ifneq (,$(filter $(DEB_HOST_ARCH), hppa sh4))
    EXTRA_OPT_CFLAGS += -fno-inline-small-functions
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
  with_pgo :=
endif

ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
  with_lto :=
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

BASE_LTO_CFLAGS = -g -fwrapv -O3
ifeq ($(with_lto),yes)
    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin

=== debian/watch ===
version=3
opts=dversionmangle=s/.*\+//,uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/3\.10(\.\d)?/Python-(3\.10[.\dabcr]*)\.tgz

## python3.10 3.10.13

=== debian/changelog ===
python3.10 (3.10.13-1) unstable; urgency=medium

  * Python 3.10.13 release.
    - Addresses CVE-2023-40217.

 -- Matthias Klose <doko@debian.org>  Fri, 25 Aug 2023 13:35:07 +0200
